
# Atari 2600 VCS linker script for bankswitch type Arcadia Supercharger
# only half of the bank combinations are supported: if first half of memory
# is set to bank 3, the addressing will be wrong

MEMORY {
 BANK1:    start=$1000, size=$0800, type=ro, file=%O, fill=yes, fillval=$00, define=yes;
 BANK2:    start=$F000, size=$0800, type=ro, file=%O, fill=yes, fillval=$00, define=yes;
 BANK3:    start=$1800, size=$0800, type=ro, file=%O, fill=yes, fillval=$00, define=yes;
 BANK4:    start=$F800, size=$0800, type=ro, file=%O, fill=yes, fillval=$00;
 HEADER:   start=$0000, size=$0100, type=ro, file=%O, fill=yes, fillval=$00;
 TIA:      start=$00,   size=$40,   type=rw, define=yes;
 RAM:      start=$80,   size=$80,   type=rw, define=yes;
 RIOT:     start=$0280, size=$20,   type=rw, define=yes;
}

SEGMENTS {
 RODATA1:   load=BANK1,    type=ro, align=$100, optional=yes;
 CODE1:     load=BANK1,    type=ro, define=yes, optional=yes;
 RODATA2:   load=BANK2,    type=ro, align=$100, optional=yes;
 CODE2:     load=BANK2,    type=ro, define=yes, optional=yes;
 RODATA3:   load=BANK3,    type=ro, align=$100, optional=yes;
 CODE3:     load=BANK3,    type=ro, define=yes, optional=yes;
 TAPEHEAD:  load=HEADER,   type=ro, align=$100;
 ZEROPAGE:  load=RAM,      type=zp;
 TIA:       load=TIA,      type=rw, define=yes, optional=yes;
 RIOT:      load=RIOT,     type=rw, define=yes, optional=yes;
}

